unit uRtfGroups;

{$INCLUDE 'RTFConv.inc'}

interface

uses
  SysUtils, Classes;

type
  TRtfGroup = class;
  TRtfGroupList = class;

  TRtfGroup = class
    private
      fFirstToken: integer;
      fLastToken: integer;
      fGroups: TRtfGroupList;
    protected
    public
      constructor Create; virtual;
      destructor Destroy; override;
      property FirstToken: integer read fFirstToken write fFirstToken;
      property LastToken: integer read fLastToken write fLastToken;
      property Groups: TRtfGroupList read fGroups;
    end;

  TRtfGroupList = class
    private
      fList: TList;
      function GetCount: integer;
      function GetItems(Index: integer): TRtfGroup;
    protected
    public
      constructor Create; virtual;
      destructor Destroy; override;
      procedure Clear; virtual;
      function Add(Item: TRtfGroup): integer; virtual;
      property Items[Index: integer]: TRtfGroup read GetItems; default;
      property Count: integer read GetCount;
    end;

implementation

{ TRtfGroupList }

constructor TRtfGroupList.Create;
begin
  inherited Create;
  fList := TList.Create;
end;

destructor TRtfGroupList.Destroy;
begin
  Clear;
  FreeAndNil(fList);
  inherited;
end;

procedure TRtfGroupList.Clear;
var i: integer;
begin
  for i := 0 to Pred(fList.Count) do
    TObject(fList[i]).Free;
  fList.Clear;
end;

function TRtfGroupList.GetCount: integer;
begin
  Result := fList.Count;
end;

function TRtfGroupList.GetItems(Index: integer): TRtfGroup;
begin
  Result := TRtfGroup(fList[Index]);
end;

function TRtfGroupList.Add(Item: TRtfGroup): integer;
begin
  Result := fList.Add(Item);
end;


{ TRtfGroup }

constructor TRtfGroup.Create;
begin
  inherited Create;
  fGroups := TRtfGroupList.Create;
end;

destructor TRtfGroup.Destroy;
begin
  FreeAndNil(fGroups);
  inherited;
end;

end.
